(defun c:Blocks_Numbering_By_Type ( / ss ent ent_n bname lst lst2 x y val val2 pointmin pointmax bobj mp )
(vl-load-com)
(setvar 'textstyle "standard")
(prompt "select blocks")
(setq ss (ssget '((0 . "INSERT"))))

(if (= ss nil)
(alert "No blocks selected ")
(progn
(setq lst '())
      (repeat (setq x (sslength ss))
        (setq ent_n (ssname ss (setq x (1- x)))
              ent (entget ent_n)
        );;close setq    

       (setq bname (getpropertyvalue ent_n "EffectiveName~Native"))
       (setq ent (cdr (assoc -1 ent)))
       (setq lst (cons (list bname ent) lst))
      );;close repeat

(setq lst (vl-sort lst '(lambda (x y) (< (car x)(car y)))))                                            
(setq lst2 '())
(setq x 0 y 1)

(repeat (length lst)
   (if (= (car (nth x lst)) (car (nth (1+ x) lst)))
     (setq lst2 (cons (list (car (nth x lst)) (cadr (nth x lst)) y) lst2))
      (progn 
       (setq lst2 (cons (list (car (nth x lst))(cadr (nth x lst)) y) lst2))
       (setq y (1+ y))
      );;close progn
   );;close if
  (setq x (1+ x))
);;close repeat
  
(foreach blk lst2
  (setq ent (cadr blk))
  (setq bobj (vlax-ename->vla-object ent))
  ;;(vla-GetBoundingBox bobj 'minpoint 'maxpoint)
  ;;(setq pointmin (vlax-safearray->list minpoint))
  ;;(setq pointmax (vlax-safearray->list maxpoint))
  ;;(setq mp (mapcar '* (mapcar '+ pointmin pointmax) '(0.5 0.5)))
  ;;(command "text" mp 1.0 0.0 (nth 2 blk))
  (LM:vl-setattributevalue bobj "ORDER" (rtos (nth 2 blk)) )
);;close foreach
                                             
);;close progn from top
);;close if from top
(princ)


)

(defun LM:vl-setattributevalue ( blk tag val )
    (setq tag (strcase tag))
    (vl-some
       '(lambda ( att )
            (if (= tag (strcase (vla-get-tagstring att)))
                (progn (vla-put-textstring att val) val)
            )
        )
        (vlax-invoke blk 'getattributes)
    )
)